//
//  main.c
//  movana
//
//  Created by Georgios Iatropoulos on 9/10/15.
//  Copyright (c) 2015 Georgios Iatropoulos. All rights reserved.
//
// This app intends to analyze and solve simple physics problems about movement.

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <float.h>

int main(int argc, const char *argv[])
{
    // Declare a variable that holds user responses
    char answer = '\0';
    // Declare a variable that holds the answers counter
    int i = 0;

    // Declare the movement quantities.
    double dx = -1.0;
    double dt = -1.0;
    double mv = -1.0;

    // Ask user what the input is gonna be.
    printf("This application analyzes and solves movement problems.\n");
    printf("Please prepare to provide the proper input to the following questions.\n");

    // Ask for spacial input.
    printf("Do you want to provide distance input?(Y/N)");
    scanf(" %c", &answer);

    while ((answer != 'Y') && (answer != 'y') && (answer != 'N') && (answer != 'n'))
    {
        printf("Invalid answer!\nPlease provide a Yes (Y) or No (N):");
        scanf(" %c", &answer);
    }

    if (answer == 'Y' || answer == 'y')
    {
        printf("Please provide distance in meters:");
        scanf(" %lf", &dx);
        i++;
        printf("First quantity's value is set.\n");
    }
    else if (answer == 'N' || answer == 'n')
    {
        printf("Proceeding...");
    }

    // Ask for time input.
    printf("Do you want to provide time input?(Y/N)");
    scanf(" %c", &answer);

    while ((answer != 'Y') && (answer != 'y') && (answer != 'N') && (answer != 'n'))
    {
        printf("Invalid answer!\nPlease provide a Yes (Y) or No (N):");
        scanf(" %c", &answer);
    }

    if (answer == 'Y' || answer == 'y')
    {
        printf("Please provide time in seconds:");
        scanf(" %lf", &dt);
        i++;
        printf("Second quantity's value is set.\n");
    }
    else if (answer == 'N' || answer == 'n')
    {
        if (i == 0)
        {
            printf("\nYou must provide 2 quantities.\n\nThis app has the purpose to calculate the quantity that is not given.\n\n");
            return 0;
        }
        printf("Proceeding...");
    }

    // Ask for velocity input.
    printf("Do you want to provide velocity input?(Y/N)");
    scanf(" %c", &answer);

    while ((answer != 'Y') && (answer != 'y') && (answer != 'N') && (answer != 'n'))
    {
        printf("Invalid answer!\nPlease provide a Yes (Y) or No (N):");
        scanf(" %c", &answer);
    }

    if (answer == 'Y' || answer == 'y')
    {
        i++;
        if (i == 2)
        {
            printf("Please provide velocity in meters per second:");
            scanf(" %lf", &mv);
        }
        else
        {
            printf("\nYou must provide 2 quantities.\n\nThis app has the purpose to calculate the quantity that is not given.\n\n");
            return 0;
        }
    }
    else if (answer == 'N' || answer == 'n')
    {
        if (i != 2)
        {
            printf("\nYou must provide 2 quantities.\n\nThis app has the purpose to calculate the quantity that is not given.\n\n");
            return 0;
        }
    }

    printf("Proceeding...\n");

    // Make the proper calculations for finding the missing quantity.
    // Velocity.
    if (mv == -1.0)
    {
        mv = dx / dt;
        printf("The average velocity in meters/second is: v = dx / dt => v = %lf m/s\n", mv);
    }
    // Distance.
    if (dx == -1.0)
    {
        dx = mv * dt;
        printf("The total distance in meters is: dx = v * dt => dx = %lf m\n", dx);
    }
    // Time.
    if (dt == -1.0)
    {
        dt = dx / mv;
        printf("The total time in seconds is: dt = dx / v => dt = %lf s\n", dt);
    }

    return 0;
}